/**
    Copyright (C) 2002, 2003  Michael Ahlberg, Måns Rullgård

    Permission is hereby granted, free of charge, to any person
    obtaining a copy of this software and associated documentation
    files (the "Software"), to deal in the Software without
    restriction, including without limitation the rights to use, copy,
    modify, merge, publish, distribute, sublicense, and/or sell copies
    of the Software, and to permit persons to whom the Software is
    furnished to do so, subject to the following conditions:

    The above copyright notice and this permission notice shall be
    included in all copies or substantial portions of the Software.

    THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
    EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
    MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
    NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
    HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
    WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
    DEALINGS IN THE SOFTWARE.
**/

#ifndef _TCTREE_H
#define _TCTREE_H

#include <tc.h>
#include <tctypes.h>

#ifdef __cplusplus
extern "C" {
#endif

typedef struct tctree tctree_t;

extern tctree_t *tctree_new(int locking, tccompare_fn cmp, uint32_t flags);
extern int tctree_find(tctree_t *t, void *key, void *ret);
extern int tctree_search(tctree_t *t, void *key, void *ret);
extern int tctree_replace(tctree_t *t, void *key, void *ret);
extern int tctree_delete(tctree_t *t, void *key, void *ret);
extern int tctree_destroy(tctree_t *t, tcfree_fn f);

#ifdef __cplusplus
}
#endif

#endif
